#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#define PSCMD "ps -o pid,ppid,state,tty,command" 
#define SLEEP_TIME 2

int main(int argc, char **argv) { 
  pid_t pid;
  int status;
  
  if ((pid = fork()) < 0) {
	perror("Fork");
	exit(1);
  }

  if (pid == 0) {
	/* child */ 
        exit(0);
  }

  /* parent */ 
  sleep(SLEEP_TIME);
  printf("\n--- With Zombie ---\n");
  system(PSCMD);

  /* wait child */
  if (wait(&status) == -1) {
	perror("Wait child");
	return -1;
  }
  printf("\nChild return status: %d\n", status);
  printf("\n--- Without Zombie ---\n");
  system(PSCMD);

  return 0;
} 
